Quantcast Wanting to Learn - ESOUI
Thread Tools Display Modes
02/25/19, 06:28 PM   #1
BSKCorp
AddOn Author - Click to view addons
Join Date: Sep 2017
Posts: 12
Wanting to Learn

O so I am sure there is a few threads with this very question buried within these forums but my few searches have came up empty. I have been trying to learn LUA. I have followed many guides and all and I have a very basic understanding of coding just from messing around with Minecraft Mods/Plugins in java as well as figuring out very crude fixes for addons like Wykkyd's full Immersion and Profile Settings. But This update has really broken many addons and some are not even going to be updated. I would like to give back to the community and make some of these addons work again, but I can't seem to figure out how to get LUA to work in Windows.

So to you fellow devs, can you help me figure out what i am doing wrong and get a LUA parser (I think that is what it's called) to work in Windows so I can learn how to code in LUA and help the ESO UI Community and keep some of our most favorite addons going?

A little insite as well, I have built a lua.exe command console using tdm gcc, lua 5.3.5 and a build script. Even though I can open the Lua program I can't run any commands in there. Would I be better off using a IDE? Thanks in advanced to anyone that can offer some words of wisdom.
  Reply With Quote
02/25/19, 06:35 PM   #2
Rhyono
AddOn Author - Click to view addons
Join Date: Sep 2016
Posts: 555
I can't give any advice on running lua locally, since I just write the code and when I think it's ready, I use the addon in-game and if it throws an error, I fix it.

As for fixing addons that are breaking: following the stack trace is the best way of figuring out what needs fixed. Since they broke with this update, the issue is very specific to ESO's variables and lua implementation, so I don't know how much a windows test environment will help for that.
  Reply With Quote
02/25/19, 07:01 PM   #3
BSKCorp
AddOn Author - Click to view addons
Join Date: Sep 2017
Posts: 12
Well I have looked at the errors on many of them but I am trying to learn how to Code LUA so I can better understand exactly how to fix it and everything has pointed me to using the console and having LUA installed on my machine. Should I not even worry about having an IDE or LUA installed on my PC if I am just wanting to do Addons and just learn the code in say, Notepad++?
  Reply With Quote
02/25/19, 07:06 PM   #4
Rhyono
AddOn Author - Click to view addons
Join Date: Sep 2016
Posts: 555
This thread can probably help on the IDE end.

Most issues probably can't be tested outside of the game.
  Reply With Quote
02/25/19, 08:01 PM   #5
BSKCorp
AddOn Author - Click to view addons
Join Date: Sep 2017
Posts: 12
@Rhyono, thank you so much. going through those threads I was able to find out eclipse had a LUA Dev tool. I am already used to Eclipse from working with java a bit for miencraft so I can sorta jump right in. Thanks for the help! even found someone who already updated a library for the latest patch for auto fills and the like. Big thanks!
  Reply With Quote
02/25/19, 08:18 PM   #6
BSKCorp
AddOn Author - Click to view addons
Join Date: Sep 2017
Posts: 12
One last question, is it ok to still be using LUA 5.1 or 5.2 or should I update the IDE to 5.3?
  Reply With Quote
02/26/19, 04:27 AM   #7
sirinsidiator
 
sirinsidiator's Avatar
AddOn Author - Click to view addons
Join Date: Apr 2014
Posts: 1,289
There are a few good recommendations on where to start - for all skill levels - in the getting started guide on the ESOUI wiki.

As for specifics about ESO's Lua version, you can check out this page. Basically it is using a customized version of Havok Script based on Lua 5.1.

In case you are using Eclipse LDT, you can download an autocompletion here.
__________________
Like what I do? Support me on Patreon!
>siri.exe MyAddon
Does your addon work? [y/n] n
There is a typo in there.
  Reply With Quote
02/26/19, 08:43 PM   #8
BSKCorp
AddOn Author - Click to view addons
Join Date: Sep 2017
Posts: 12
I have gotten into and already have the auto completion but the wiki needs updating I think. I am doing the Combat tutorial and in
AddontestIndicator:SetHidden(not inCombat) line it throws a error in game,

EDIT - I found the error and in the XML had FooaddonIndicator not Addontest T_T

user:/AddOns/AddonTest/Addontest.lua:15: attempt to index a nil value
stack traceback:
user:/AddOns/AddonTest/Addontest.lua:15: in function 'Addontest.OnPlayerCombatState'
<Locals> event = 131430, inCombat = true </Locals>

user:/AddOns/AddonTest/Addontest.lua:15: attempt to index a nil value
stack traceback:
user:/AddOns/AddonTest/Addontest.lua:15: in function 'Addontest.OnPlayerCombatState'
<Locals> event = 131430, inCombat = false </Locals>

Last edited by BSKCorp : 02/26/19 at 09:03 PM.
  Reply With Quote

ESOUI » Developer Discussions » Lua/XML Help » Wanting to Learn

Thread Tools
Display Modes

Posting Rules
You may not post new threads
You may not post replies
You may not post attachments
You may not edit your posts

vB code is On
Smilies are On
[IMG] code is On
HTML code is Off